CC      := arm-elf-gcc
LD      := arm-elf-ld
OBJCOPY := arm-elf-objcopy
OBJDUMP := arm-elf-objdump
AFLAGS  := -D__ASSEMBLY__  -Os  -fno-strict-aliasing  -fno-common -mshort-load-bytes -msoft-float -gdwarf-2 -D__arm__ -DTEXT_BASE=0x00000000 -fno-builtin -pipe  -mapcs-32 -march=armv4 -c -o
CFLAGS  := -Os  -fno-strict-aliasing  -fno-common -mshort-load-bytes -msoft-float -gdwarf-2 -D__arm__ -DTEXT_BASE=0x00000000 -fno-builtin -pipe  -mapcs-32 -march=armv4 -Wall -Wstrict-prototypes -gdwarf-2 -c -o 
CNOFLAGS:= -O0  -fno-strict-aliasing  -fno-common -mshort-load-bytes -msoft-float -gdwarf-2 -D__arm__ -DTEXT_BASE=0x00000000 -fno-builtin -pipe  -mapcs-32 -march=armv4 -Wall -Wstrict-prototypes -gdwarf-2 -c -o 
LDFLAGS := -nostdlib -Bstatic 
#GCCLIB  := $(shell $(CC) -print-file-name=libc.a) $(shell $(CC) -print-libgcc-file-name)
GCCLIB  := $(shell $(CC) -print-libgcc-file-name)
OBJS    := isr.o main.o timer.o moxauart.o dbg_uart.o lib.o xmodem.o console.o \
		   memory.o ctype.o exrtc.o gpio.o spi_asm.o \
		   watch_dog.o i2c.o spi.o tftp.o arp.o mac.o ip.o udpburn.o proc232.o \
		   vsprintf.o string.o exspi.o ai.o Calibration.o mptester.o dio.o

all : main start.o $(OBJS) armboot

start.o : start.S
	$(CC) $(AFLAGS) start.o start.S

spi_asm.o : spi_asm.S spi_reg.h
	$(CC) $(AFLAGS) spi_asm.o spi_asm.S

isr.o : isr.c isr.h
	$(CC) $(CFLAGS) isr.o isr.c


main.o : main.c
	$(CC) $(CFLAGS) main.o main.c

timer.o : timer.c
	$(CC) $(CFLAGS) timer.o timer.c

moxauart.o : moxauart.c moxauart.h
	$(CC) $(CFLAGS) moxauart.o moxauart.c

dbg_uart.o : dbg_uart.c dbg_uart.h
	$(CC) $(CFLAGS) dbg_uart.o dbg_uart.c

lib.o : lib.c 
	$(CC) $(CFLAGS) lib.o lib.c

xmodem.o : xmodem.c 
	$(CC) $(CNOFLAGS) xmodem.o xmodem.c

console.o : console.c 
	$(CC) $(CFLAGS) console.o console.c

memory.o : memory.c  
	$(CC) $(CFLAGS) memory.o memory.c

ctype.o : ctype.c
	$(CC) $(CFLAGS) ctype.o ctype.c
	
vsprintf.o : vsprintf.c
	$(CC) $(CFLAGS) vsprintf.o vsprintf.c	

string.o : string.c
	$(CC) $(CFLAGS) string.o string.c

exrtc.o : exrtc.c
	$(CC) $(CFLAGS) exrtc.o exrtc.c

gpio.o : gpio.c
	$(CC) $(CFLAGS) gpio.o gpio.c

watch_dog.o : watch_dog.c
	$(CC) $(CFLAGS) watch_dog.o watch_dog.c
	
exspi.o : exspi.c
	$(CC) $(CFLAGS) exspi.o exspi.c

spi.o : spi.c spi.h spi_reg.h
	$(CC) $(CFLAGS) spi.o spi.c

Calibration.o : Calibration.c Calibration.h
	$(CC) $(CFLAGS) Calibration.o Calibration.c
	
ai.o : ai.c
	$(CC) $(CFLAGS) ai.o ai.c

dio.o : dio.c
	$(CC) $(CFLAGS) dio.o dio.c

i2c.o : i2c.c
	$(CC) $(CFLAGS) i2c.o i2c.c

tftp.o : tftp.c tftp.h
	$(CC) $(CFLAGS) tftp.o tftp.c
	
arp.o : arp.c
	$(CC) $(CFLAGS) arp.o arp.c

mac.o : mac.c mac.h global.h
	$(CC) $(CFLAGS) mac.o mac.c

ip.o : ip.c
	$(CC) $(CFLAGS) ip.o ip.c

udpburn.o : udpburn.c
	$(CC) $(CFLAGS) udpburn.o udpburn.c

proc232.o : proc232.c
	$(CC) $(CFLAGS) proc232.o proc232.c

mptester.o : mptester.c
	$(CC) $(CFLAGS) mptester.o mptester.c

armboot : start.o $(OBJS) armboot.lds
	$(LD) $(LDFLAGS) -T armboot.lds -Ttext 0x00000000 start.o $(OBJS) $(GCCLIB) -Map armboot.map -o armboot
	$(OBJDUMP) -D armboot > armboot.dis	
	$(OBJCOPY)  -O srec armboot armboot.srec
	$(OBJCOPY)  -O ihex armboot armboot.hex
	$(OBJCOPY)  -O binary armboot TestPrg.bin

main:
	rm -rf main.o

clean:
	rm -rf *.o
	rm -rf *.bin
	rm -rf *.bak 

doxy:
	make -C doxygen
